VERSION 5.00
Object = "{FE0065C0-1B7B-11CF-9D53-00AA003C9CB6}#1.0#0"; "COMCT232.OCX"
Begin VB.Form FrmRotoWave 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "RotoWave"
   ClientHeight    =   4365
   ClientLeft      =   1845
   ClientTop       =   1500
   ClientWidth     =   3675
   Icon            =   "FrmRotoWave.frx":0000
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   NegotiateMenus  =   0   'False
   ScaleHeight     =   291
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   245
   Begin ComCtl2.UpDown UdCos 
      Height          =   195
      Left            =   3285
      TabIndex        =   0
      Top             =   3720
      Width           =   240
      _ExtentX        =   423
      _ExtentY        =   344
      _Version        =   327680
      Value           =   4
      Max             =   5
      Min             =   1
      Enabled         =   -1  'True
   End
   Begin VB.PictureBox PicMain 
      BackColor       =   &H00000000&
      ClipControls    =   0   'False
      ForeColor       =   &H00000000&
      Height          =   3435
      Left            =   120
      LinkTimeout     =   0
      ScaleHeight     =   225
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   225
      TabIndex        =   2
      TabStop         =   0   'False
      Top             =   120
      Width           =   3435
   End
   Begin ComCtl2.UpDown UdSin 
      Height          =   195
      Left            =   3285
      TabIndex        =   1
      Top             =   4020
      Width           =   240
      _ExtentX        =   423
      _ExtentY        =   344
      _Version        =   327680
      Value           =   2
      Max             =   5
      Min             =   1
      Enabled         =   -1  'True
   End
   Begin VB.Label LblSin 
      BackColor       =   &H00000000&
      BorderStyle     =   1  'Fixed Single
      Caption         =   "2"
      ForeColor       =   &H0000FF00&
      Height          =   255
      Left            =   3060
      TabIndex        =   4
      Top             =   3990
      Width           =   495
   End
   Begin VB.Label LblCos 
      BackColor       =   &H00000000&
      BorderStyle     =   1  'Fixed Single
      Caption         =   "4"
      ForeColor       =   &H0000FF00&
      Height          =   255
      Left            =   3060
      TabIndex        =   3
      Top             =   3690
      Width           =   495
   End
End
Attribute VB_Name = "FrmRotoWave"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' Author:   Stuart Pennington.
' Project:  Rotating Waves.
' Feedback: elwick@ukonline.co.uk



' Variables That Hold The Values Displayed In The Labels.
' Used For Drawing The Waves And Keeping The Loop Optimized
' (Faster To Read A Variable Than A Property).
Private CosVal%
Private SinVal%


' ################################################################################################################################
'
Private Declare Function TextOut& Lib "gdi32" Alias "TextOutA" (ByVal ahDc&, ByVal x1&, ByVal y1&, ByVal lpString$, ByVal nCount&)
'
' The TextOut function writes a character string at the specified location,
' using the currently selected font.
'
'    PARAMETERS.
'
' 1. Identifies the device context.
'
' 2. Specifies the logical x-coordinate of the reference point
'    that Windows uses to align the string.
'
' 3. Specifies the logical y-coordinate of the reference point
'    that Windows uses to align the string.
'
' 4. Points to the string to be drawn.
'    The string does not need to be zero-terminated,
'    since cbString specifies the length of the string.
'
' 5. Specifies the number of characters in the string.
'
' ################################################################################################################################


Private Const Pi As Single = 3.14159265358979
Private Const TwoPi As Single = 6.28318530717959
Private Sub Form_Load()

    ' Initialize Variables.
    CosVal = 4
    SinVal = 2

    ' Set The Scale Mode Of The Picture Box.
    PicMain.Scale (-Pi, 2)-(Pi, -2)

    ' Position The Form On The Screen.
    Move (Screen.Width - Width) \ 2, (Screen.Height - Height) \ 3

End Sub
Private Sub Form_Activate()

    Dim DotPos!, Offset!  ' Used For Drawing The Wave.

    ' Outer Loop: Rotates The Wave.
    ' Inner Loop: Draws The Wave In It's Current Orientation.

    Do
      For Offset = 0 To TwoPi Step 0.03
          PicMain.Cls
          For DotPos = -Pi To Pi Step 0.02
              ' Draw The Wave.
              PicMain.PSet (2 * Cos(CosVal * DotPos - Offset), 1.5 * Sin(SinVal * DotPos + Offset)), &HFF00&
              ' Draw The Wave Again In Reverse So That Each Dot
              ' Is Displayed For The Same Length Of Time.
              ' Rem Out The Next Line And You'll See What I Mean.
              PicMain.PSet (2 * Cos(-CosVal * DotPos - Offset), 1.5 * Sin(-SinVal * DotPos + Offset)), &HFF00&
          Next
          DoEvents
      Next
    Loop

End Sub
Private Sub UdCos_Change()

    ' Update Variable And Label.

    CosVal = UdCos.Value
    LblCos.Caption = CosVal

End Sub
Private Sub UdSin_Change()

    ' Update Variable And Label.

    SinVal = UdSin.Value
    LblSin.Caption = SinVal

End Sub
Private Sub Form_Paint()

    ' The AutoRedraw Property Of The Form Is False
    ' so Update The Interface.

    TextOut hDC, 122, 248, "Cos Frequency:", 14
    TextOut hDC, 122, 268, "Sin Frequency:", 14

End Sub
Private Sub Form_Unload(Cancel%)

    ' Break The Loop By Ending The Program.
    End

End Sub
